Attribute VB_Name = "MobileComm"
'Functions for Agilent Mobile Communications DC source

Option Explicit

Public Sub set_MC_voltage(volts As String, output As String, instrument As VisaComLib.FormattedIO488)
'Sets voltage
    
    Dim command As String
    
    command = "VOLT" & output & " " & volts
    sendCmd command, instrument
End Sub

Public Sub set_MC_current(amps As String, output As String, instrument As VisaComLib.FormattedIO488)
'Sets current
    Dim command As String
    
    command = "CURR" & output & " " & amps
    sendCmd command, instrument
End Sub

Public Sub set_MC_output(state As String, output As String, instrument As VisaComLib.FormattedIO488)
'Sets output state
    Dim command As String
    
    command = "OUTP" & output & " " & state
    sendCmd command, instrument
End Sub

Public Sub set_MC_resistance(resistance As String, instrument As VisaComLib.FormattedIO488)
'Sets programmable resistance
    Dim command As String
    
    command = "RES " & resistance
    sendCmd command, instrument
End Sub

Public Sub set_MC_MeasRang(range As String, instrument As VisaComLib.FormattedIO488)
'Sets current measurement range
    Dim command As String
    
    command = "SENS:CURR:RANG " & range
    sendCmd command, instrument
End Sub

Public Function meas_MC_Curr(output As String, instrument As VisaComLib.FormattedIO488, Optional param As String)
'Measures and returns output current for channel 1 or channel 2
    Dim answer As String
    Dim command As String
    
    If hasAdvMeas = 1 And output = "1" Then
        command = "MEAS:CURR:" & param & "?"
    Else:
        command = "MEAS:CURR" & output & "?"
    End If
    
    meas_MC_Curr = sendQry(command, instrument)
End Function

Public Function meas_MC_Volt(output As String, instrument As VisaComLib.FormattedIO488, Optional param As String)
'Measures and returns output voltage for channel 1 or channel 2
    Dim command As String
    
    If hasAdvMeas = 1 And output = "1" Then
        command = "MEAS:VOLT:" & param & "?"
    Else:
        command = "MEAS:VOLT" & output & "?"
    End If
    meas_MC_Volt = sendQry(command, instrument)
End Function

Public Function meas_MC_DVM(param As String, instrument As VisaComLib.FormattedIO488)
'Measures optional DVM voltage
    Dim command As String
    
    command = "MEAS:DVM:" & param & "?"
    meas_MC_DVM = sendQry(command, instrument)
End Function

Public Sub set_MC_compmode(compmode As String, modN As String, instrument As VisaComLib.FormattedIO488)
'Sets output compensation mode
    Dim command As String

    If modN = "66309" Or modN = "66311" Then
        command = "OUTP:TYPE " & compmode
    Else
        command = "OUTP:COMP:MODE " & compmode
    End If

    sendCmd command, instrument
End Sub
